# Basic information
%define driver_name qla2xxx
%define driver_version 
%define release 1

%define dversion %( (echo "%{driver_version}" | cut -d '-' -f1) )

%define kmod_vendor qlgc 
%define kmod_name qla2xxx
%define kmod_full_name %{kmod_vendor}-%{kmod_name}

%ifarch i686 x86_64 ia64
%define xenvar xen
%endif

%ifarch i686
%define paevar PAE
%endif

%define upvar ""
%{!?kvariants: %define kvariants %{?upvar} %{?xenvar} %{?paevar}}

Summary:	Linux driver for QLogic's qla2xxx Fibre Channel Card
Name:		%{kmod_full_name}-kmod
Version:	%{dversion}
Release:	%{release}
License:        GPL
Group:          System Environment/Kernel
Source0:        %{driver_name}-%{driver_version}.tgz
Source1:	kmodtool
Distribution:	Linux
Vendor:		QLogic Corp.
Packager:	Poorna Pathipaka <poorna.pathipaka@qlogic.com>
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i386 i686 x86_64 ppc64

%define kmodtool bash %{SOURCE1}

%{!?kernel_version: %define kernel_version %( if [ -z "$KERNEL" ]; then ( echo "`uname -r`"); else ( echo "$KERNEL"); fi )}

# Kernel version without kernel flavor
%define kverrel %(%{kmodtool} verrel %{?kernel_version} 2>/dev/null)


%description
qla2xxx - QLogic's HBA driver for Linux.

%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_full_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
%setup -q -c -T -a 0
for kvariant in %{kvariants} ; do
    cp -a %{driver_name}-%{driver_version} _kmod_build_$kvariant
done

%build
for kvariant in %{kvariants} ; do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    make -C "${ksrc}" modules M=$PWD
    popd
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{kmod_full_name}

for kvariant in %{kvariants} ; do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    make -C "${ksrc}" modules_install M=$PWD
    popd
done

%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Sat Mar 28 2009 Lalit Chandivade <lalit.chandivade@qlogic.com>
- Packaging 8.02.00.51.05.03-k
* Fri Feb 20 2009 Poorna Pathipaka <poorna.pathipaka@qlogic.com>
- Relesed with driver version 8.02.00.06.05.03-k
- Sample spec file with kmod support
